using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Grouping; 

namespace GridRelationSample
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridGroupingControl1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridGroupingControl1 = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).BeginInit();
			this.SuspendLayout();
			// 
			// gridGroupingControl1
			// 
			this.gridGroupingControl1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.gridGroupingControl1.BackColor = System.Drawing.SystemColors.Window;
			this.gridGroupingControl1.Location = new System.Drawing.Point(8, 8);
			this.gridGroupingControl1.Name = "gridGroupingControl1";
			this.gridGroupingControl1.Size = new System.Drawing.Size(584, 432);
			this.gridGroupingControl1.TabIndex = 0;
			this.gridGroupingControl1.Text = "gridGroupingControl1";
			this.gridGroupingControl1.VersionInfo = "4.401.0.49";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(600, 446);
			this.Controls.Add(this.gridGroupingControl1);
			this.Name = "Form1";
			this.Text = "Form1";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			DataSet ds = new DataSet();
			ds.Tables.Add(GetEmployeeTable());
			ds.Tables.Add(GetDepartmentTable());
			this.gridGroupingControl1.DataSource = ds.Tables["Employee"] ; 
			this.gridGroupingControl1.SourceListSet.Add("Department",(ds.Tables["Department"] as IList) );   

			GridRelationDescriptor relation = new GridRelationDescriptor("Emp_Dept");
			relation.MappingName = "DeptNo";
			relation.ChildTableName = "Department";
			relation.RelationKind = RelationKind.ForeignKeyKeyWords;
			relation.RelationKeys.Add("DeptNo","Dept");  

			this.gridGroupingControl1.TableDescriptor.Relations.Add(relation);     
			
			this.gridGroupingControl1.TableDescriptor.VisibleColumns.Remove("Emp_Dept_DeptName");   
			this.gridGroupingControl1.TableDescriptor.VisibleColumns.Remove("Emp_Dept_DeptDescription");   
			this.gridGroupingControl1.TableDescriptor.Columns["Emp_Dept_DeptNo"].HeaderText = "DeptNo"; 

		
		}

		#region DataTable
		public DataTable GetEmployeeTable()
		{
			DataTable dt = new DataTable("Employee");
			dt.Columns.Add("EmpNo",typeof(int));
			dt.Columns.Add("EmpName",typeof(string));
			dt.Columns.Add("DeptNo",typeof(int));
			dt.Columns.Add("EmpAddress",typeof(string));
			
			for(int i = 0;i< 15;i++)
			{
				DataRow row = dt.NewRow(); 
				row[0] = i;
				row[2] = i%4;
				row[1] = string.Format("EmployeeName {0}",i);
				row[3] = string.Format("EmployeeAddress {0}",i);
				dt.Rows.Add(row); 
			}
			dt.AcceptChanges();
			return dt;
		}
		public DataTable GetDepartmentTable()
		{
			DataTable dt = new DataTable("Department");
			dt.Columns.Add("DeptNo",typeof(int));
			dt.Columns.Add("DeptName",typeof(string));
			dt.Columns.Add("DeptDescription",typeof(string));
			dt.Columns.Add("Dept",typeof(int));

			for(int i = 0;i< 4;i++)
			{
				DataRow row = dt.NewRow(); 
				row[0] = i;
				row[3] = i;
				row[1] = string.Format("DepartmentName {0}",i);
				row[2] = string.Format("DepartmentDescription {0}",i);
				dt.Rows.Add(row); 
			}
			dt.AcceptChanges();
			return dt;
		}

		#endregion
	}
}
